<?php
defined('ABSPATH') or die();
const AIOMATIC_DEFAULT_BIG_TIMEOUT = 999;
const AIOMATIC_DEFAULT_MODEL = 'gpt-4.1-mini';
const AIOMATIC_DEFAULT_IMAGE_MODEL = 'dalle3';
const AIOMATIC_MODELS = array('gpt-3.5-turbo-instruct');
const AIOMATIC_MODELS_CHAT = array('gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1', 'gpt-4.1-2025-04-14', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'gpt-3.5-turbo', 'gpt-3.5-turbo-16k', 'gpt-3.5-turbo-1106', 'gpt-3.5-turbo-0125', 'gpt-4', 'gpt-4-0314', 'gpt-4-0613', 'gpt-4-32k', 'gpt-4-32k-0314', 'gpt-4-32k-0613', 'gpt-4-1106-preview', 'gpt-4-0125-preview', 'gpt-4-turbo-preview', 'gpt-4-vision-preview', 'gpt-4-turbo-2024-04-09', 'gpt-4-turbo', 'gpt-4o', 'gpt-4o-2024-05-13', 'gpt-4o-2024-08-06', 'gpt-4o-2024-11-20', 'chatgpt-4o-latest', 'o1-preview', 'o1-pro', 'o1-preview-2024-09-12', 'o1-mini', 'o1-mini-2024-09-12', 'o3', 'o3-2025-04-16', 'o4-mini', 'o4-mini-2025-04-16', 'o3-mini', 'o3-mini-2025-01-31', 'o1', 'o1-2024-12-17');
const AIOMATIC_MODELS_VISION = array('gpt-4-vision-preview', 'gpt-4-turbo-2024-04-09', 'gpt-4-turbo', 'gpt-4o', 'gpt-4o-2024-05-13', 'gpt-4o-2024-08-06', 'gpt-4o-2024-11-20', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-2025-04-14', 'gpt-4.1', 'gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'chatgpt-4o-latest', 'o1', 'o1-2024-12-17');
const AIOMATIC_MODELS_OLLAMA_VISION = array('llama3.2-vision', 'llava', 'llava-llama3', 'bakllava', 'moondream', 'llava-phi3', 'hhao/openbmb-minicpm-llama3-v-2_5', 'aiden_lu/minicpm-v2.6', 'minicpm-v', 'xuxx/minicpm2.6', 'benzie/llava-phi-3', 'mskimomadto/chat-gph-vision', 'xiayu/openbmb-minicpm-llama3-v-2_5', '0ssamaak0/xtuner-llava', 'srizon/pixie', 'jyan1/paligemma-mix-224', 'knoopx/llava-phi-2', 'nsheth/llama-3-lumimaid-8b-v0.1-iq-imatrix', 'rohithbojja/llava-med-v1.6', 'anas/video-llava', 'bigbug/minicpm-v2.5', 'qnguyen3/nanollava', 'knoopx/mobile-vlm',
'nsheth/llava-llama-3-8b-v1_1-int4', 'ManishThota/llava_next_video', 'mannix/llava-phi3', 'dimweb/bunny-llama3-8b-v', 'chatgph/gph-main', 'childof7sins/llava-llama3-f16', 'doreilly/minicpm26', 'zctech/x-ai-vis', 'rohithbojja/llava-med-v1.5', 'leilasultan/florencemed', 'HammerAI/openbmb-minicpm-llama3-v-2_5', 'knoopx/obsidian', 'ih0dl/ardo', 'ManishThota/llava-video-merge', 'ih0dl/octocore.multimodal.v0.1', 'sroecker/moondream', 'doreilly/minicpm26_q5_k_m', 'agurla/moondream', 'sparksammy/samantha-mixed', 'bfhui/smart-pig', 'darkneighbor667/prac04', 'astra/astralm2-7b', 'injoon5/shoe-explainer', 'doreilly/minicpm26_q4_k_m', 'archiea/dobie-em', 'giannisan/penny', 'chevalblanc/gpt-4o-mini', 'highsunz/llava', 'aratan/vision', 'bfhui/better-siri', 'mike/vision', 'pdevine/vision-test', 'rameshrajamani/vision', 'arkohut/minicpm-v', 'abhiraj/uml_reader', 'starsnatched/radiology', 'jmorgan/llava', 'zxf945/minicpm-v', 'sparksammy/micro-sep', 'AnonY0324/bunny-llama-3-8b', 'sparksammy/agsamantha', 'sparksammy/samantha-eggplant', 'darkneighbor667/prac03', 'bigbug/test', 'hhui/fan1.0');
const AIOMATIC_ASSISTANT_MODELS = array('gpt-3.5-turbo', 'gpt-3.5-turbo-1106', 'gpt-3.5-turbo-0125', 'gpt-3.5-turbo-16k', 'gpt-4', 'gpt-4-0613', 'gpt-4-1106-preview', 'gpt-4-0125-preview', 'gpt-4-turbo-preview', 'gpt-4-vision-preview', 'gpt-4-turbo-2024-04-09', 'gpt-4-turbo', 'gpt-4o', 'gpt-4o-2024-05-13', 'gpt-4o-2024-08-06', 'gpt-4o-2024-11-20', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-2025-04-14', 'gpt-4.1', 'gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'chatgpt-4o-latest', 'o1-preview', 'o1-pro', 'o1-preview-2024-09-12', 'o1-mini', 'o1-mini-2024-09-12', 'o3', 'o3-2025-04-16', 'o4-mini', 'o4-mini-2025-04-16', 'o3-mini', 'o3-mini-2025-01-31', 'o1', 'o1-2024-12-17');
const AIOMATIC_RETRIEVAL_MODELS = array('gpt-3.5-turbo', 'gpt-3.5-turbo-1106', 'gpt-3.5-turbo-0125', 'gpt-4-1106-preview', 'gpt-4-0125-preview', 'gpt-4-turbo-preview', 'gpt-4-vision-preview', 'gpt-4-turbo-2024-04-09', 'gpt-4-turbo', 'gpt-4o', 'gpt-4o-2024-05-13', 'gpt-4o-2024-08-06', 'gpt-4o-2024-11-20', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-2025-04-14', 'gpt-4.1', 'gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'chatgpt-4o-latest', 'o1-preview', 'o1-pro', 'o1-preview-2024-09-12', 'o1-mini', 'o1-mini-2024-09-12', 'o3', 'o3-2025-04-16', 'o4-mini', 'o4-mini-2025-04-16', 'o3-mini', 'o3-mini-2025-01-31', 'o1', 'o1-2024-12-17');
const AIOMATIC_PERPLEXITY_MODELS = array('sonar', 'sonar-pro', 'sonar-reasoning', 'sonar-reasoning-pro', 'sonar-deep-research', 'r1-1776');
const AIOMATIC_EDIT_MODELS = array();
const AIOMATIC_REALTIME_MODELS = array('gpt-4o-realtime-preview-2024-12-17', 'gpt-4o-mini-realtime-preview-2024-12-17', 'gpt-4o-realtime-preview-2024-10-01', 'gpt-4o-realtime-preview', 'gpt-4o-mini-realtime-preview');
const AIOMATIC_DEFAULT_REALTIME_MODEL = 'gpt-4o-realtime-preview-2024-12-17';
const AIOMATIC_REALTIME_VOICES = array('verse', 'alloy', 'ash', 'ballad', 'coral', 'echo', 'sage', 'shimmer');
const AIOMATIC_DEFAULT_REALTIME_VOICE = 'verse';
const AIOMATIC_DEFAULT_MODEL_EMBEDDING = 'text-embedding-3-small';
const AIOMATIC_EMBEDDINGS_MODELS = array('text-embedding-3-small', 'text-embedding-3-large', 'text-embedding-ada-002');
const AIOMATIC_DALLE_IMAGE_MODELS = array('dalle2', 'dalle3', 'dalle3hd');
const AIOMATIC_NVIDIA_MODELS = array('nvidia/llama-3.1-nemotron-70b-instruct', 'nvidia/nemotron-4-mini-hindi-4b-instruct', 'ibm/granite-guardian-3.0-8b', 'ibm/granite-3.0-8b-instruct', 'ibm/granite-3.0-3b-a800m-instruct', 'zyphra/zamba2-7b-instruct', 'nvidia/mistral-nemo-minitron-8b-8k-instruct', 'nvidia/llama-3.1-nemotron-70b-reward', 'meta/llama-3.2-3b-instruct', 'meta/llama-3.2-1b-instruct', 'nvidia/llama-3.1-nemotron-51b-instruct', 'qwen/qwen2-7b-instruct', 'abacusai/dracarys-llama-3.1-70b-instruct', 'ai21labs/jamba-1.5-mini-instruct', 'nvidia/nemotron-mini-4b-instruct', 'microsoft/phi-3.5-moe-instruct', 'microsoft/phi-3.5-mini-instruct', 'mistralai/mathstral-7b-v0.1', 'rakuten/rakutenai-7b-instruct', 'rakuten/rakutenai-7b-chat', 'mistralai/mistral-large-2-instruct', 'writer/palmyra-fin-70b-32k', 'thudm/chatglm3-6b', 'baichuan-inc/baichuan2-13b-chat', 'meta/llama-3.1-70b-instruct', 'meta/llama-3.1-8b-instruct', 
'nv-mistralai/mistral-nemo-12b-instruct', 'nvidia/llama3-chatqa-1.5-70b', 'nvidia/llama3-chatqa-1.5-8b', '01-ai/yi-large', 'nvidia/nemotron-4-340b-instruct', 'writer/palmyra-med-70b-32k', 'writer/palmyra-med-70b', 'upstage/solar-10.7b-instruct', 'mediatek/breeze-7b-instruct', 'ibm/granite-34b-code-instruct', 'ibm/granite-8b-code-instruct', 'aisingapore/sea-lion-7b-instruct', 'microsoft/phi-3-mini-4k-instruct', 'mistralai/mixtral-8x22b-instruct-v0.1', 'meta/llama3-70b-instruct', 'meta/llama3-8b-instruct', 'google/codegemma-7b', 'google/gemma-2b', 'google/gemma-7b', 'meta/codellama-70b', 'mistralai/mixtral-8x7b-instruct-v0.1');
const AIOMATIC_XAI_MODELS = array('grok-beta', 'grok-vision-beta', 'grok-2-vision-1212', 'grok-2-1212', 'grok-2', 'grok-2-latest', 'grok-3', 'grok-3-latest');
const AIOMATIC_VISION_XAI_MODELS = array('grok-vision-beta', 'grok-2-vision-1212', 'grok-3', 'grok-3-latest');
const AIOMATIC_GROQ_MODELS = array('distil-whisper-large-v3-en', 'gemma2-9b-it', 'llama-3.3-70b-versatile', 'llama-3.1-8b-instant', 'llama-guard-3-8b', 'llama3-70b-8192', 'llama3-8b-8192', 'mixtral-8x7b-32768', 'mistral-saba-24b', 'qwen-2.5-coder-32b', 'qwen-2.5-32b', 'deepseek-r1-distill-qwen-32b', 'deepseek-r1-distill-llama-70b-specdec', 'deepseek-r1-distill-llama-70b', 'llama-3.3-70b-specdec', 'llama-3.2-1b-preview', 'llama-3.2-3b-preview', 'llama-3.2-11b-vision-preview', 'llama-3.2-90b-vision-preview');
const AIOMATIC_VISION_GROQ_MODELS = array('llama-3.2-11b-vision-preview', 'llama-3.2-90b-vision-preview');
const AIOMATIC_AZURE_MODELS = array('o1', 'o1-preview', 'o1-pro', 'o1-mini', 'o3', 'o3-2025-04-16', 'o4-mini', 'o4-mini-2025-04-16', 'o3-mini', 'gpt-3.5-turbo', 'gpt-3.5-turbo-16k', 'gpt-3.5-turbo-1106', 'gpt-4', 'gpt-4-vision-preview', 'gpt-4-1106-preview', 'gpt-4-0125-preview', 'gpt-4-0613', 'gpt-4-0314', 'gpt-4-32k-0613', 'gpt-4-32k-0314', 'gpt-4-32k', 'gpt-4-turbo', 'gpt-4-turbo-2024-04-09', 'gpt-4o', 'gpt-4o-2024-05-13', 'gpt-4o-2024-08-06', 'gpt-4o-2024-11-20', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-2025-04-14', 'gpt-4.1', 'gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'gpt-3.5-turbo-instruct', 'gpt-3.5-turbo-instruct-0914', 'text-embedding-3-large', 'text-embedding-3-small', 'text-embedding-ada-002');
const AIOMATIC_CLAUDE_MODELS = array('claude-3-7-sonnet-20250219', 'claude-3-5-haiku-20241022', 'claude-3-5-sonnet-20241022', 'claude-3-5-sonnet-20240620', 'claude-3-opus-20240229', 'claude-3-sonnet-20240229', 'claude-3-haiku-20240307', 'claude-instant-1', 'claude-instant-1.2', 'claude-2.0', 'claude-2.1');
const AIOMATIC_CLAUDE_CHAT = array('claude-3-7-sonnet-20250219', 'claude-3-5-haiku-20241022', 'claude-3-5-sonnet-20241022', 'claude-3-5-sonnet-20240620', 'claude-3-opus-20240229', 'claude-3-sonnet-20240229', 'claude-3-haiku-20240307');
const AIOMATIC_CLAUDE_MODELS_200K = array('claude-3-7-sonnet-20250219', 'claude-3-5-haiku-20241022', 'claude-3-5-sonnet-20241022', 'claude-3-5-sonnet-20240620', 'claude-3-opus-20240229', 'claude-3-sonnet-20240229', 'claude-3-haiku-20240307', 'claude-2.1');
const AIOMATIC_VISION_CLAUDE_MODELS = array('claude-3-7-sonnet-20250219', 'claude-3-5-haiku-20241022', 'claude-3-5-sonnet-20241022', 'claude-3-5-sonnet-20240620', 'claude-3-opus-20240229', 'claude-3-sonnet-20240229', 'claude-3-haiku-20240307');
const AIOMATIC_GOOGLE_MODELS = array('gemma-3-27b-it', 'gemini-2.0-flash-thinking-exp-01-21', 'gemini-2.5-pro-exp-03-25', 'gemini-2.0-pro-exp-02-05', 'gemini-1.5-flash-latest', 'gemini-exp-1206', 'learnlm-1.5-pro-experimental', 'gemini-2.0-flash-exp', 'gemini-2.0-flash', 'gemini-2.0-flash-lite', 'gemini-1.5-flash-8b-latest', 'gemini-1.5-pro-latest', 'chat-bison-001', 'text-bison-001');
const AIOMATIC_GOOGLE_VISION_MODELS = array('gemma-3-27b-it', 'gemini-2.0-flash-thinking-exp-01-21', 'gemini-2.5-pro-exp-03-25', 'gemini-2.0-pro-exp-02-05', 'gemini-1.5-flash-latest', 'gemini-exp-1206', 'learnlm-1.5-pro-experimental', 'gemini-2.0-flash-exp', 'gemini-2.0-flash', 'gemini-2.0-flash-lite', 'gemini-1.5-flash-8b-latest', 'gemini-1.5-pro-latest');
const AIOMATIC_GOOGLE_STREAMING_MODELS = array('gemma-3-27b-it', 'gemini-2.0-flash-thinking-exp-01-21', 'gemini-2.5-pro-exp-03-25', 'gemini-2.0-pro-exp-02-05', 'gemini-1.5-pro-latest', 'gemini-1.5-flash-latest', 'gemini-exp-1206', 'learnlm-1.5-pro-experimental', 'gemini-2.0-flash-exp', 'gemini-2.0-flash', 'gemini-2.0-flash-lite', 'gemini-1.5-flash-8b-latest');
const AIOMATIC_STABLE_NEW_MODELS = array('stable-diffusion-ultra', 'stable-diffusion-core', 'stable-diffusion-3-0-large', 'stable-diffusion-3-0-turbo', 'stable-diffusion-3-0-medium', 'sd3.5-large', 'sd3.5-large-turbo', 'sd3.5-medium');
const AIOMATIC_IDEOGRAM_MODELS = array('V_2_TURBO', 'V_2', 'V_1_TURBO', 'V_1');
const AIOMATIC_STABLE_DEFAULT_MODE = 'sd3.5-large-turbo';
const AIOMATIC_REPLICATE_DEFAULT_API_VERSION = 'ac732df83cea7fff18b8472768c88ad041fa750ff7682a21affe81863cbe77e4';
const AIOMATIC_STABLE_IMAGE_MODELS = array('stable-diffusion-xl-1024-v1-0', 'stable-diffusion-v1-6', 'stable-diffusion-ultra', 'stable-diffusion-core', 'stable-diffusion-3-0-large', 'stable-diffusion-3-0-medium', 'stable-diffusion-3-0-turbo', 'sd3.5-large', 'sd3.5-large-turbo', 'sd3.5-medium');
const AIOMATIC_GOOGLE_EMBEDDINGS_MODELS = array('embedding-001', 'text-embedding-004', 'text-embedding-005');
const AIOMATIC_BATCH_MODELS = array('gpt-3.5-turbo', 'gpt-3.5-turbo-16k', 'gpt-4', 'gpt-4-32k', 'gpt-4-turbo-preview', 'gpt-4-vision-preview', 'gpt-4-turbo', 'gpt-3.5-turbo-1106', 'gpt-4-0314', 'gpt-4-turbo-2024-04-09', 'gpt-4-32k-0314', 'gpt-4-32k-0613', 'text-embedding-3-large', 'text-embedding-3-small', 'text-embedding-ada-002', 'gpt-4o', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-2025-04-14', 'gpt-4.1', 'gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'chatgpt-4o-latest', 'o1-preview', 'o1-pro', 'o1-preview-2024-09-12', 'o1-mini', 'o1-mini-2024-09-12', 'o3', 'o3-2025-04-16', 'o4-mini', 'o4-mini-2025-04-16', 'o3-mini', 'o3-mini-2025-01-31', 'o1', 'o1-2024-12-17');
const AIOMATIC_BATCH_MODELS_NO_EMBEDDING = array('gpt-3.5-turbo', 'gpt-3.5-turbo-16k', 'gpt-4', 'gpt-4-32k', 'gpt-4-turbo-preview', 'gpt-4-vision-preview', 'gpt-4-turbo', 'gpt-3.5-turbo-1106', 'gpt-4-0314', 'gpt-4-turbo-2024-04-09', 'gpt-4-32k-0314', 'gpt-4-32k-0613');
const AIOMATIC_FUNCTION_CALLING_MODELS = array('gpt-3.5-turbo', 'gpt-3.5-turbo-0125', 'gpt-3.5-turbo-1106', 'gpt-4', 'gpt-4-turbo-preview', 'gpt-4-0125-preview', 'gpt-4-1106-preview', 'gpt-4-0613', 'gpt-4-turbo-2024-04-09', 'gpt-4-turbo', 'gpt-4o', 'gpt-4o-2024-05-13', 'gpt-4o-2024-08-06', 'gpt-4o-2024-11-20', 'gpt-4o-mini', 'gpt-4o-mini-2024-07-18', 'gpt-4.1-nano-2025-04-14', 'gpt-4.1-nano', 'gpt-4.1-2025-04-14', 'gpt-4.1', 'gpt-4.1-mini', 'gpt-4.1-mini-2025-04-14', 'gpt-4.5-preview', 'gpt-4.5-preview-2025-02-27', 'gpt-4o-mini-search-preview', 'gpt-4o-search-preview', 'o1-preview', 'o1-pro', 'o1-preview-2024-09-12', 'o1-mini', 'o1-mini-2024-09-12', 'o3', 'o3-2025-04-16', 'o4-mini', 'o4-mini-2025-04-16', 'o3-mini', 'o3-mini-2025-01-31', 'o1', 'o1-2024-12-17');
const AIOMATIC_XAI_FUNCTION_CALLING_MODELS = array('grok-beta', 'grok-vision-beta', 'grok-2-vision-1212', 'grok-2-1212', 'grok-2', 'grok-2-latest', 'grok-3', 'grok-3-latest');
const AIOMATIC_GOOGLE_CHAT_MODELS = array('gemma-3-27b-it', 'gemini-2.0-flash-thinking-exp-01-21', 'gemini-2.5-pro-exp-03-25', 'gemini-2.0-pro-exp-02-05', 'gemini-1.5-flash-latest', 'gemini-exp-1206', 'learnlm-1.5-pro-experimental', 'gemini-2.0-flash-exp', 'gemini-2.0-flash', 'gemini-2.0-flash-lite', 'gemini-1.5-flash-8b-latest', 'gemini-1.5-pro-latest');
const AIOMATIC_GOOGLE_FUNCTION_CALLING_MODELS = array('gemma-3-27b-it', 'gemini-2.0-flash-thinking-exp-01-21', 'gemini-2.5-pro-exp-03-25', 'gemini-2.0-pro-exp-02-05', 'gemini-1.5-flash-latest', 'gemini-exp-1206', 'learnlm-1.5-pro-experimental', 'gemini-2.0-flash-exp', 'gemini-2.0-flash', 'gemini-2.0-flash-lite', 'gemini-1.5-flash-8b-latest', 'gemini-1.5-pro-latest');
const AIOMATIC_GROQ_FUNCTION_CALLING_MODELS = array('distil-whisper-large-v3-en', 'gemma2-9b-it', 'llama-3.3-70b-versatile', 'llama-3.1-8b-instant', 'llama-guard-3-8b', 'llama3-70b-8192', 'llama3-8b-8192', 'mixtral-8x7b-32768', 'mistral-saba-24b', 'qwen-2.5-coder-32b', 'qwen-2.5-32b', 'deepseek-r1-distill-qwen-32b', 'deepseek-r1-distill-llama-70b-specdec', 'deepseek-r1-distill-llama-70b', 'llama-3.3-70b-specdec', 'llama-3.2-1b-preview', 'llama-3.2-3b-preview', 'llama-3.2-11b-vision-preview', 'llama-3.2-90b-vision-preview');
const AIOMATIC_OLLAMA_FUNCTION_CALLING_MODELS = array('deepseek-r1', 'llama3.3', 'phi4', 'llama3.2', 'llama3.1', 'qwen2.5', 'nemotron-mini', 'mistral-small', 'mistral-nemo', 'mistral', 'mixtral', 'command-r', 'command-r-plus', 'qwen2', 'qwen2.5-coder', 'mistral-large', 'gdisney/mistral-large-uncensored', 'hermes3', 'llama3-groq-tool-use', 'crown/artificium', 'firefunction-v2', 'rolandroland/llama3.1-uncensored', 'mannix/llama3.1-8b-abliterated', 'ajindal/llama3.1-storm', 'mannix/llama3.1-8b-lexi', 'wangshenzhi/llama3.1_8b_chinese_chat', 'incept5/llama3.1-claude', 'sam4096/qwen2tools', 'Yarflam/pouet', 'finalend/hermes-3-llama-3.1', 'ALIENTELLIGENCE/nextjs14', 'allenporter/xlam', 'wangshenzhi/llama3.1_70b_chinese_chat', 'MFDoom/deepseek-coder-v2-tool-calling', 'steamdj/llama3.1-cpu-only', 'gdisney/mistral-nemo-uncensored', 'yantien/llama3.1-uncensored', 'hhao/qwen2.5-coder-tools', 'HammerAI/hermes-3-llama-3.1', 'crown/darkidol', 'finalend/llama-3.1-storm', 'mannix/llama3.1-storm', 'ALIENTELLIGENCE/whiterabbitv2', 'benedict/linkbricks-llama3.1-korean', 'leeplenty/lumimaid-v0.2', 'HammerAI/mistral-nemo-uncensored', 
'vanilj/llama-3.1-70b-instruct-lorablated-iq2_xs', 'mannix/hermes-3-llama-3.1-8b', 'vanilj/hermes-3-llama-3.1-8b', 'mtaylor91/llama3.2-uncensored', 'kuro/mistral-nemo-minitron-8b-base-q8_0-gguf', 'xiayu/wc-llama-bk-8', 'mannix/llama3-groq-tool-8b', 'sammcj/qwen2.5-coder-7b-instruct', 'rjmalagon/dolphin-2.9.3-mistral-nemo', 'ALIENTELLIGENCE/codewriterv2', 'rjmalagon/lumimaid-v0.2-12b', 'hhao/qwen2.5-tools', 'xe/mimi', 'allenporter/assist-llm', 'imac/mistral-nemo-instruct-2407', 'fingerliu/llama3.1', 'MFDoom/deepseek-v2-tool-calling', 'interstellarninja/llama3.1-8b-tools', 'tomasmcm/undi95-meta-llama-3.1-8b-claude', 'krtkygpta/gemma2_tools', 'vanilj/supernova-medius', 'ALIENTELLIGENCE/sarahv2', 'lucianotonet/llamaclaude', 'kuqoi/qwen2-tools', 'rscr/vikhr_nemo_12b', 'mannix/llama3.1-70b', 'chevalblanc/o1-mini', 'ALIENTELLIGENCE/cybersecuritythreatanalysisv2', 'mike/mistral', 'interstellarninja/hermes-2-pro-llama-3-8b-tools', 'ALIENTELLIGENCE/cyberaisecurityv2', 'krith/meta-llama-3.2-3b-instruct-uncensored', 'krith/meta-llama-3.1-8b-instruct', 'sammcj/deepseek-coder-v2-lite-toolcalling', 'majx13/test', 'Tohur/natsumura-assistant-llama-3.1', 
'ALIENTELLIGENCE/attorney2', 'vanilj/calme-2.4-rys-78b', 'xiayu/wc-llama-bk-7', 'goekdenizguelmez/josiefied-qwen2.5-7b-abliterated-v2', 'zcohn/llama3.1-uncensored-cot', 'mannix/hermes-3-llama-3.1-70b', 'krith/qwen2.5-7b-instruct', 'ALIENTELLIGENCE/linuxcmdxpert', 'sammcj/llama-3-1-8b-smcleod-golang-coder-v3', 'krith/qwen2.5-14b-instruct', 'cyberwald/sauerkrautlm-nemo-12b-instruct', 'vanilj/llama3.1-70b-iquants', 'interstellarninja/hermes-3-llama-3.1-8b-tools', 'dwightfoster03/functionary-small-v3.1', 'kangali/room-coder', 'mannix/llama3.1-8b', 'phuzzy/darknemo', 'ALIENTELLIGENCE/codingassistantv2', 'mychen76/llama3.1-intuitive-thinker', 'ALIENTELLIGENCE/roleplaymaster', 'krith/meta-llama-3.1-70b-instruct-abliterated', 'fatfish/internal-ref-extractor', 'benedict/linkbricks-mistral-nemo-korean', 'krith/meta-llama-3.2-1b-instruct-uncensored', 'xiayu/wc-llama3.1-0805', 'ALIENTELLIGENCE/cybersecuritymonitoring', 'xiayu/wc-llama-bk-2', 'ALIENTELLIGENCE/pythoncoderv2', 'krith/mistral-nemo-instruct-2407-abliterated', 'ALIENTELLIGENCE/automationgeneratorv2', 'InfoForge/forge-8b', 'rjmalagon/dolphin-2.9.3-mistral', 'phuzzy/darkllama3.1', 'ALIENTELLIGENCE/psychologistv2', 
'rjmalagon/llama-3.1-supernova-lite', 'd89ftekb7/mistral-nemo-uncensored', 'ticlazau/qwen2.5-coder-7b-instruct', 'krith/meta-llama-3.1-8b-instruct-abliterated', 'ALIENTELLIGENCE/medicalimaginganalysis', 'ALIENTELLIGENCE/deepseekcoder16kcontextv2', 'vanilj/mistral-nemo-gutenberg-12b-v2', 'ALIENTELLIGENCE/contentsummarizer', 'krith/qwen2.5-72b-instruct', 'krith/meta-llama-3.1-70b-instruct', 'sam4096/phi2tools', 'ALIENTELLIGENCE/imagepromptengineer', 'TheAzazel/qwen2.5-14b-instruct-abliterated', 'ALIENTELLIGENCE/medicaldiagnostictools', 'ALIENTELLIGENCE/deeplearningengineerv2', 'ALIENTELLIGENCE/holybible', 'rongfengliang/openbuddy-llama3.1', 'ALIENTELLIGENCE/personalizednutrition', 'rongfengliang/bamboo-llm', 'bazsalanszky/mistral-large', 'zxf945/mistral-nemo', 
'ALIENTELLIGENCE/randomroleplaypromptgenerator', 'ALIENTELLIGENCE/lawfirm', 'vitoreafeliciano/deepseek-coder', 'vitoreafeliciano/codefuse-deepseek', 'SlyOtis/git-auto-message', 'ALIENTELLIGENCE/genaiimagecspromptv', 'ALIENTELLIGENCE/mechanicalengineerv2', 'rscr/vikhr_llama3.1_8b', 'socialnetwooky/hermes3-llama3.1-abliterated', 'ALIENTELLIGENCE/computerhardwareengineer', 'ALIENTELLIGENCE/chemicalengineer', 'ALIENTELLIGENCE/ai2ndbrain', 'krith/qwen2.5-32b-instruct', 'ALIENTELLIGENCE/buffett', 'ALIENTELLIGENCE/aidatascientistv2', 'ALIENTELLIGENCE/bioengineerbiomedicalengineer', 'ALIENTELLIGENCE/electricalengineerv2', 'goekdenizguelmez/josiefied-qwen2.5-1.5b-instruct-abliterated-v1', 'krith/mistral-small-instruct-2409', 'rscr/vikhr_llama3.2_1b', 'ALIENTELLIGENCE/mentalwellness', 'ALIENTELLIGENCE/musicindustry', 'kangali/room-research', 'ALIENTELLIGENCE/multiagentv2', 'ALIENTELLIGENCE/characterconversationsimulator', 'ALIENTELLIGENCE/personalizedmedicine', 'ALIENTELLIGENCE/marketingexpertv2', 'jean-luc/cydonia', 'vanilj/cathallama-70b-i1-iq2_s', 'ALIENTELLIGENCE/predictiveanalyticsforbusinesses', 'artifish/llama3.2-uncensored', 'ALIENTELLIGENCE/musicprompts', 'ALIENTELLIGENCE/jarvisv2',
'solonglin/qwen2.5-q6_k-abliterated', 'anpigon/qwen2.5-7b-instruct-kowiki', 'ALIENTELLIGENCE/structureddataextraction', 'rjmalagon/rys_llama-3.1-8b-instruct', 'ALIENTELLIGENCE/computervisionengineer', 'RobinBially/xlam-8k', 'ALIENTELLIGENCE/radiofrequencyengineer', 'ALIENTELLIGENCE/streamingdefenselevel3', 'ALIENTELLIGENCE/filmandvideoproduction', 'ALIENTELLIGENCE/modelcreate2', 'starsnatched/thinking', 'ALIENTELLIGENCE/plantdoctor', 'ALIENTELLIGENCE/gamemasterroleplaying', 'ALIENTELLIGENCE/medicalbillingandcoding', 'flori/llama3.1-wopr', 'ALIENTELLIGENCE/gourmetglobetrotter', 'RobinBially/llama3.1-32k', 'ALIENTELLIGENCE/avengineer', 'ALIENTELLIGENCE/chiefinformationsecurityofficerv2', 'ALIENTELLIGENCE/grantwriterv2', 'benedict/linkbricks-hermes3-llama3.1-8b-korean-advanced-q8', 'ALIENTELLIGENCE/seomanager', 'ALIENTELLIGENCE/contractanalyzerv2', 'ALIENTELLIGENCE/digitalmarketingexpert', 'ALIENTELLIGENCE/financialadvisor', 'ALIENTELLIGENCE/veterinarymedicine', 'kovacs/llama3.1', 'ALIENTELLIGENCE/doctorai', 'ALIENTELLIGENCE/aerospaceengineer', 'ALIENTELLIGENCE/unrealgamedev', 'ALIENTELLIGENCE/startupagiassistant2', 'interstellarninja/hermes-2-theta-llama-3-8b-tools', 'vanilj/mistral-large-instruct-2407-iq3_xx', 
'ALIENTELLIGENCE/lyricist', 'ALIENTELLIGENCE/mindwell', 'ALIENTELLIGENCE/civilengineerv2', 'Artalius/lixi', 'adhilroshan/uiforger', 'ALIENTELLIGENCE/extremecreativityerebus', 'ALIENTELLIGENCE/aipromptassistant', 'ALIENTELLIGENCE/tesla', 'darsankumar89/leglai', 'ALIENTELLIGENCE/mindpal', 'ALIENTELLIGENCE/teachai', 'krith/mistral-large-instruct-2407', 'RobinBially/qwen2.5-coder-16k', 'InfoForge/openforge', 'ALIENTELLIGENCE/embeddedsystemsengineer', 'ALIENTELLIGENCE/leonardodavinci', 'Shailesh714/emotion', 'ALIENTELLIGENCE/schematicdesign', 'ALIENTELLIGENCE/yourcfov2', 'chrypnotoad/erebus', 'Maoyue/mistral-nemo-minitron-8b-instruct', 'teevorian/mistral-nemo-sauerkraut', 'isaacramthal/llama3.1', 'froehnerel/llama-3.1-storm', 'ALIENTELLIGENCE/sapabapcoder', 'site-ir-llm/llm', 'ALIENTELLIGENCE/projectmanager', 'ALIENTELLIGENCE/shelldonv2', 'ALIENTELLIGENCE/librarianv2', 'ALIENTELLIGENCE/tutorai', 'TheAzazel/replete-llm-2.5-qwen-14b', 'ALIENTELLIGENCE/brainstorming', 'ALIENTELLIGENCE/searchfund', 'lawmancs2024/qwen2-function-q5', 'ALIENTELLIGENCE/aipoweredlawfirms', 'ALIENTELLIGENCE/chloev2', 'timdata_seturan/llm-botika-fp16', 'johnnyboy/qwen2.5-math-7b', 'DaddyLLAMA/euryale_v2.2_q4', 
'TheAzazel/replete-llm-2.5-qwen-7b', 'TheAzazel/replete-llm-2.5-qwen-32b', 'phuzzy/darkidol', 'Kevinization/medicllama1.6', 'laszlo/bob-silly-dungeon-master', 'ALIENTELLIGENCE/humancomputerinteractiondesigner', 'ALIENTELLIGENCE/accountingandtaxation', 'ALIENTELLIGENCE/veterinarian', 
'rjmalagon/llama-spark', 'ALIENTELLIGENCE/suntzu', 'ALIENTELLIGENCE/alberteinstein', 'ALIENTELLIGENCE/airesearcherv2', 'ALIENTELLIGENCE/pythonconsultantv2', 'ALIENTELLIGENCE/chiefaccountingofficerv2', 'ALIENTELLIGENCE/carljung', 'ALIENTELLIGENCE/edgarcaycev2', 'etracker/sauerkrautlm-3.1-instruct-q8', 'k33g/jean-luc-picard', 'zenoverflow/replete_coder_3_1_8b_q8_custom', 'ALIENTELLIGENCE/roominteriorsuggester', 'ALIENTELLIGENCE/psychiatrist', 'ALIENTELLIGENCE/policymaker', 'ahmedag/hackerbot_spl', 'ALIENTELLIGENCE/generalcounselv2', 'ALIENTELLIGENCE/tutoraiblueprint', 'vanilj/qwen2.5-72b-instruct-iq3_xxs', 'ALIENTELLIGENCE/engineeringtechnicalmanuals', 'ALIENTELLIGENCE/strategist', 'ALIENTELLIGENCE/alienbuddy', 'ALIENTELLIGENCE/emotionalintelligenceanalysis', 'ALIENTELLIGENCE/constructiontakeoffestimatorv2', 'ALIENTELLIGENCE/ceov2', 'ALIENTELLIGENCE/staugustine', 'michaelbui/qwen2.5-14b', 'ALIENTELLIGENCE/genealogist', 'ALIENTELLIGENCE/mindreaderdecoder', 'ALIENTELLIGENCE/foodservice', 'ALIENTELLIGENCE/neuralnetworkengineer', 'ALIENTELLIGENCE/nlpengineer2', 'cow/gemma2_tools', 'TheAzazel/qwen2.5-1.5b-v3-instruct-abliterated-v3.q8_0', 'TheAzazel/qwen2.5-coder-7b-instruct-abliterated.q8_0', 'siswabaru001/pussertifai', 
'rjmalagon/barcena-8b-juridico-mexicano', 'rohitrajt/emotibot', 'ALIENTELLIGENCE/humorbot', 'ALIENTELLIGENCE/sentimentanalyzer', 'ALIENTELLIGENCE/insuranceservices', 'sparksammy/samantha-3.1', 'ALIENTELLIGENCE/systemsengineer', 'ALIENTELLIGENCE/productmanager', 'ALIENTELLIGENCE/chiefmarketingofficer2', 'ALIENTELLIGENCE/civilstructureengineerv2', 'AG1/kbmtderfla', 'crown/golang3.1', 'ALIENTELLIGENCE/crewaiconsultant', 'ALIENTELLIGENCE/askai', 'ALIENTELLIGENCE/hackerreporter', 'ALIENTELLIGENCE/geotechnicalengineer', 'ALIENTELLIGENCE/healthcareservices', 'ALIENTELLIGENCE/rockefeller', 'ALIENTELLIGENCE/riskmanager', 
'ALIENTELLIGENCE/officemanager', 'ALIENTELLIGENCE/socialmediamanager', 'ALIENTELLIGENCE/chiefbusinessdevelopmentofficerv2', 'mike/firefunction', 'Kevinization/medicllama1.7', 'benedict/linkbricks-hermes3-llama3.1-8b-korean-advanced-q4', 'ALIENTELLIGENCE/coworkingmanager', 'ALIENTELLIGENCE/manufacturingprogrammingengineer', 'ALIENTELLIGENCE/businessintelligencedeveloper', 'ALIENTELLIGENCE/fashiondesign', 'ALIENTELLIGENCE/stressmoodmentalhealthsupport', 'ArzzKurz/koreansupport', 'ALIENTELLIGENCE/datacollectionentryanalysis', 'ALIENTELLIGENCE/nuclearengineer', 'ALIENTELLIGENCE/projectconstructionmanager', 'ALIENTELLIGENCE/trainingmanager', 'ALIENTELLIGENCE/brandmanager', 'chrypnotoad/fucksorry', 'ALIENTELLIGENCE/chiefsalesofficer2', 'ALIENTELLIGENCE/chiefaiofficerv2', 'thirty3/linux', 'TheAzazel/replete-llm-2.5-qwen-1.5b', 'benevolentjoker/the_economistmini', 'mhw/sin', 'ALIENTELLIGENCE/lifecoach', 'zctech/x-ai-dev', 'ALIENTELLIGENCE/startupcommunity', 'ALIENTELLIGENCE/aigaming', 'timdata_seturan/llm-botika', 'ALIENTELLIGENCE/travelplanningbooking', 'ALIENTELLIGENCE/incidentresponseautomation', 'ALIENTELLIGENCE/dentistry', 'ALIENTELLIGENCE/constructionplanning', 'ALIENTELLIGENCE/jesusofnazareth', 'ALIENTELLIGENCE/crisisintervention', 
'ALIENTELLIGENCE/materialsengineer', 'ALIENTELLIGENCE/designmanager', 'ALIENTELLIGENCE/salesmanager', 'eliocosta/teste', 'jmorgan/msn', 'Kevinization/medicllama1.10', 'vanilj/llama-3.1-instruct-bellman-8b-swedish', 'bippy/rnld', 'magejosh/llama32instruct1buncensoredq6k', 'thirty3/kali', 'TheAzazel/replete-llm-2.5-qwen-3b', 'sthenno/miscii-14b-preview', 't/qwen2.5', 'RobinBially/qwen2.5-16k', 'aratan/valeryh', 'rizkiagungid/rasxgpt', 'fatfish/external-ref-extractor', 'luobin/coder', 'pdevine/discollama-unsloth', 'ALIENTELLIGENCE/enoch', 'ALIENTELLIGENCE/virtualfinancialadvisors', 'ALIENTELLIGENCE/automatedaccountingtaxpreparation', 'ALIENTELLIGENCE/horticulture', 'ALIENTELLIGENCE/pharmacy', 'ALIENTELLIGENCE/surveyingandmapping', 'mikolajewski/emojitron', 'ALIENTELLIGENCE/plato', 'ALIENTELLIGENCE/socrates', 'ALIENTELLIGENCE/shunryusuzuki', 'ALIENTELLIGENCE/aiengineer', 'ALIENTELLIGENCE/telecommunicationsengineer', 'ALIENTELLIGENCE/serverlesscomputingengineer', 'ALIENTELLIGENCE/metallurgicalengineer', 'dansullivan/test1', 'rosemarla/mistral-small-instruct-abliterated', 'Tales/llama_doc', 'DaddyLLAMA/magum_v2_123b_iq3_xxs', 'rizkiagungid/rasxlite2', 'abhisharma/mini_alisa', 'abhisharma/saniya', 'dominic/adamlinux', 
'dharmapurikar/qwen2.5-7b-64k', 'rscr/llama3_70b_ru', 'franek/analytics', 'InfoForge/forge-70b', 'ALIENTELLIGENCE/solopreneur', 'ALIENTELLIGENCE/machinelearningengineerv2', 'saifsprezi/sprezi-llama-8b', 'ALIENTELLIGENCE/startupventurestudio', 'ALIENTELLIGENCE/ufology', 'ALIENTELLIGENCE/personalizedmarketingcampaigns', 'ALIENTELLIGENCE/aipowerededucationalgames', 'ALIENTELLIGENCE/clinicaltrialmanagement', 'ALIENTELLIGENCE/virtualeventplanning', 'ALIENTELLIGENCE/predictivethreatdetection', 'ALIENTELLIGENCE/mindfulnessandmeditation', 'ALIENTELLIGENCE/internetofthingsiot', 'ALIENTELLIGENCE/designsimulation', 'ALIENTELLIGENCE/financialplanning', 'ALIENTELLIGENCE/governmentagencies', 'ALIENTELLIGENCE/transportationandlogistics', 'ALIENTELLIGENCE/hawking', 'ALIENTELLIGENCE/elderlycompanion', 'ALIENTELLIGENCE/spectrumanalyzer', 'ALIENTELLIGENCE/ethicalphilosopher', 'ALIENTELLIGENCE/newsproducer', 'ALIENTELLIGENCE/investigativejournalist', 'ALIENTELLIGENCE/healthsafetyengineer', 'ALIENTELLIGENCE/agriculturalengineer', 'ALIENTELLIGENCE/noamchomsk', 'ALIENTELLIGENCE/conceptualdesigntutor', 'jiayuan1/bamboo', 'Azazel-AI/qwen2.5-14b-instruct-abliterated-v2-q8_0', 'mtaylor91/l3-stheno-maid-blackroot', 'anisha24/model1_llama3.1', 'DaddyLLAMA/magum_123b_iq4_xs', 'vanilj/qwen2.5-32b-instruct_iq4_xs',
'zxf945/llama3.2', 'FjordAI/fjord-ai', 'Kevinization/medicllama1.9.2.q8', 'blinzki/bimtrazer', 'Kevinization/medicllama1.5', 'ALIENTELLIGENCE/detectiveanya', 'ALIENTELLIGENCE/fitgenius', 'ALIENTELLIGENCE/pcarchitect', 'ALIENTELLIGENCE/christiancounselor', 'ALIENTELLIGENCE/airegulatoryspecialist', 'ALIENTELLIGENCE/airesearchscientist', 'ALIENTELLIGENCE/terrorismexpert', 'ALIENTELLIGENCE/sustainabilityanalysistools', 'ALIENTELLIGENCE/portfoliomanagement', 
'ALIENTELLIGENCE/intelligenttutoringsystems', 'ALIENTELLIGENCE/virtualteachingassistants', 'ALIENTELLIGENCE/supplychainoptimization', 'ALIENTELLIGENCE/tourismhospitalitymanagement', 'ALIENTELLIGENCE/textileandapparelmanufacturing', 'ALIENTELLIGENCE/manufacturing', 'ALIENTELLIGENCE/educationservices', 'ALIENTELLIGENCE/retail', 'ALIENTELLIGENCE/shakespeare', 'ALIENTELLIGENCE/enriquecastillorincon', 'ALIENTELLIGENCE/newsreporter', 'shamyukr2904/gynocologist', 'ALIENTELLIGENCE/signalprocessingengineer', 'ALIENTELLIGENCE/realestatebroker', 'ALIENTELLIGENCE/realestateagent', 'ALIENTELLIGENCE/arvrcloudengineer', 'ALIENTELLIGENCE/ancientalienttheorist', 'ALIENTELLIGENCE/mininggeologicalengineer', 'ALIENTELLIGENCE/environmentalengineer', 'ALIENTELLIGENCE/advertisingmanager', 'ALIENTELLIGENCE/businessadministrator', 'ALIENTELLIGENCE/digitalmarketingmanager', 'ALIENTELLIGENCE/businessdevelopmentbizdev', 'ALIENTELLIGENCE/chiefprojectmanager', 'ALIENTELLIGENCE/coretransformation', 'artifish/spongeass-v4', 'chimiste/llama-3.1-8b-graph', 'DaddyLLAMA/euryale_v2.2_q6_k', 'Hamberfim/myguru_v04', 'abhisharma/alisa', 'gwyntel/psm-v2', 'vince_ai/mmmistral', 'gwyntel/psr-v5', 'rohitrajt/sihemotibot', 'starsnatched/thinkingmistral', 'franek/bank-statement-analyzer', 'jayeshusa22/sensei', 'XTeMixX/ai-x', 
'AG1/sdso', 'gtandon/ft_llama3_1_swe_bench', 'AG1/gc', 'AG1/strat', 'AG1/manufengprog', 'ALIENTELLIGENCE/learningguidementortutor', 'ALIENTELLIGENCE/birbal', 'ALIENTELLIGENCE/footballcoachassistant', 'RobinBially/mistral-nemo-16k', 'ALIENTELLIGENCE/madamhelenablavatsky', 'ALIENTELLIGENCE/cloudengineer', 'ALIENTELLIGENCE/aiaccessibility', 'ALIENTELLIGENCE/aiethicist', 'ALIENTELLIGENCE/aipoweredproductrecommendations', 'ALIENTELLIGENCE/personalizedducationplans', 'ALIENTELLIGENCE/virtualconsultingservices', 'ALIENTELLIGENCE/virtualnursingassistants', 'ALIENTELLIGENCE/communityengagement', 'ALIENTELLIGENCE/accessibilityservices', 'ALIENTELLIGENCE/urbanplanning', 'ALIENTELLIGENCE/seniorsvirtualassistant', 'ALIENTELLIGENCE/specialneedseducation', 'ALIENTELLIGENCE/confucius', 'ALIENTELLIGENCE/turing', 'ALIENTELLIGENCE/galileo', 'ALIENTELLIGENCE/leaddev', 'maxtheconquerer/mentorships-analysis', 'ALIENTELLIGENCE/yogananda', 'ALIENTELLIGENCE/bezos', 'ALIENTELLIGENCE/sigmundfreud', 'ALIENTELLIGENCE/tvchiefmeteorologist', 'ALIENTELLIGENCE/tvlocalnewsproducer', 'ALIENTELLIGENCE/realtimeeditor', 'ALIENTELLIGENCE/broadcastchiefengineer', 'ALIENTELLIGENCE/microwaveengineer', 'ALIENTELLIGENCE/industrializingmachinelearningengineer', 'ALIENTELLIGENCE/laotse', 'ALIENTELLIGENCE/marineengineernavalarchitect', 'ALIENTELLIGENCE/petroleumengineer', 
'ALIENTELLIGENCE/salesengineer', 'ALIENTELLIGENCE/industrialengineer', 'ALIENTELLIGENCE/projectsuperintendent', 'ALIENTELLIGENCE/tonystark', 'ALIENTELLIGENCE/predesignresearchtutor', 'ALIENTELLIGENCE/kimclement', 'venetanji/llama3.2-tool', 'Tales/parametros', 'Emile/filou', 'DaddyLLAMA/chronos_platinum_72b_q4_k_m', 'worstcoaster/tinyfilth', 'lly/qwen2.5-32b-instruct-iq3_m', 'guna/ihac-llama-3.2-3b-instruct-4', 'wwwcy/test1', 'benevolentjoker/demarquiscousin', 'vanilj/qwen2.5-14b-instruct-iq4_xs', 'benevolentjoker/the_illustrator', 'guna/ihac-llama-3.2-3b-instruct-2', 'DaddyLLAMA/replete_llm_v2.5_qwen_72b_q5_k_m', 'guna/ihac-llama-3.2-3b-instruct', 'benevolentjoker/the_caldecott', 'toan/hi', 'anthonyarutyunov/ollama-mini', 'dmovalente23/diogo_virtualente_v1', 'Nicotaglia/clinia_v3_8b', 'Nicotaglia/clinia_v2', 'RobinBially/qwen2.5-12k', 'niveo/laminha3.1', 'akiii/mochibi_3b', 'AG1/btderfla', 'panalepe/my_finetune', 'ahmedag/llama-3.1-spl-assistant', 'AG1/jbojfo', 'AG1/cdtfo', 'AG1/edgc', 'AG1/lrbof', 'jxjwilliam/bestitconsulting', 'AG1/ftngen', 'AG1/pcojof', 'AG1/chrof', 'AG1/chopof', 'AG1/sfsf', 'EZZYDMAN/summarisey', 'hhbach/ollama', 'ALIENTELLIGENCE/earthstationoperationsassistant', 
'pki/logpt2', 'mhw/sin-ia', 'sammcj/llama-3-1-8b-smcleod-golang-coder-v1', 'ALIENTELLIGENCE/player2games', 'ALIENTELLIGENCE/esolevelestimator', 'ALIENTELLIGENCE/venturestartupstudiodragons', 'ALIENTELLIGENCE/startupventurestudionnllapproach', 'ALIENTELLIGENCE/startupventurestudioplaybook', 'RobinBially/mistral-nemo-8k', 'dsi/model', 'ALIENTELLIGENCE/aiprivateequityrollups', 'ALIENTELLIGENCE/vonbraun', 'ALIENTELLIGENCE/aiinputoutputmanager', 'ALIENTELLIGENCE/virtualproductdemonstrations', 'ALIENTELLIGENCE/automatedorderfulfillment', 'ALIENTELLIGENCE/virtualtutoringservices', 'ALIENTELLIGENCE/aipoweredportfoliomanagement', 'ALIENTELLIGENCE/virtualnursingservices', 'ALIENTELLIGENCE/aipoweredpatientengagement', 'ALIENTELLIGENCE/digitalconciergeervices', 'ALIENTELLIGENCE/personalizedcustomerexperience', 'MTBS/anonymizer', 'ALIENTELLIGENCE/ecofriendlysupplychainoptimization', 'ALIENTELLIGENCE/automatedaccountingsystems', 'ALIENTELLIGENCE/adaptivelearningplatforms', 'ALIENTELLIGENCE/aquaculture', 'ALIENTELLIGENCE/gamingservice', 'ALIENTELLIGENCE/autonomousystem', 'ALIENTELLIGENCE/digitaltwintechnology', 'ALIENTELLIGENCE/environmentalconsulting', 'ALIENTELLIGENCE/realestateservice', 'ALIENTELLIGENCE/moses', 'ALIENTELLIGENCE/travelandhospitality', 'ALIENTELLIGENCE/prayerlinecrisisintervention', 'ALIENTELLIGENCE/prayerline', 'ALIENTELLIGENCE/paultheapostle',
'ALIENTELLIGENCE/archimedes', 'ALIENTELLIGENCE/newton', 'ALIENTELLIGENCE/aristotle', 'kelvi23/axum', 'ALIENTELLIGENCE/feynman', 'ALIENTELLIGENCE/raykurzweil', 'ALIENTELLIGENCE/dalecarnegie', 'ALIENTELLIGENCE/kissinger', 'ALIENTELLIGENCE/aynrand', 'ALIENTELLIGENCE/raydalio', 'ALIENTELLIGENCE/samwalton', 'ALIENTELLIGENCE/jackwelch', 'ALIENTELLIGENCE/peterdrucker', 'ALIENTELLIGENCE/howardhughes', 'ALIENTELLIGENCE/benjaminfranklin', 'ALIENTELLIGENCE/tvnationalnewscastproducer', 'ALIENTELLIGENCE/tvcommercialproducer', 
'ALIENTELLIGENCE/tvdirectorofsales', 'ALIENTELLIGENCE/streamingsalesinsights', 'ALIENTELLIGENCE/mastercontroloperator', 'ALIENTELLIGENCE/tvadsalesdirector', 'ALIENTELLIGENCE/digitalanchorproducer', 'ALIENTELLIGENCE/broadcastproductionengineer', 'ALIENTELLIGENCE/tvstationchiefengineer', 'ALIENTELLIGENCE/broadcastengineer', 'ALIENTELLIGENCE/tvchiefengineer', 'ALIENTELLIGENCE/mediaengineer', 'ALIENTELLIGENCE/neuromorphicngineer', 'ALIENTELLIGENCE/publicrelationsdirector', 'ALIENTELLIGENCE/communicationsdirector', 'ALIENTELLIGENCE/promotionsmanager', 'ALIENTELLIGENCE/facilitiesmanager', 'ALIENTELLIGENCE/marketingcommunicationmgr', 'Clem81/test', 'zctech/x-ai-12b', 'jelebruh/qwen2.5', 'chimiste/llama-3.2-1b-graph', 'guna/regpg-ihac-llama-3.2-3b-instruct', 'DaddyLLAMA/llama3.2_1b_q4', 'AG1/mqzbtm', 'vince_ai/mmmistral8', 'kufudemir/kufudemir', 'aratan/codebiblia', 'uwbfritz/mgannon', 'Nicotaglia/clinia_v4', 't/qwen2.5-patent-claims-explain', 'Nicotaglia/clinia_v3_70b', 'RobinBially/llama3.1-16k', 'Nicotaglia/clinia_v1', 'incept5/swiftral', 'starsnatched/tm', 'liutechs/soulqwen2', 'starsnatched/t', 'AG1/mrafafa', 'AG1/pscocfofo', 'AG1/rsmefofo', 'blackalpha/todlymist', 'AG1/arefofo', 'AG1/mafetfoo', 'AG1/syefofo', 'AG1/sfefofofo', 'AG1/cmhfofo', 'AG1/emefofo', 'AG1/elgfofo',
'AG1/chlgfofo', 'AG1/caifofo', 'AG1/cpvfofo', 'benedict/linkbricks-hermes3-llama3.1-70b-korean-advanced-q5', 'benedict/linkbricks-hermes3-llama3.1-70b-korean-advanced-q4', 'AG1/chrfeof', 'AG1/chepofd', 'AG1/cafafafo', 'AG1/chsavbfo', 'AG1/chdtfo', 'AG1/chstfo', 'AG1/chtafofo', 'AG1/mnmetfo', 'AG1/chfofofo', 'AG1/clstfofo', 'AG1/atfgo', 'AG1/nktfgo', 'AG1/rkfgo', 'AG1/rdfgf', 'AG1/mfskfo', 'AG1/mdfgo', 'AG1/hwkofo', 'AG1/dmfo', 'AG1/ctmof', 'AG1/cnsfo', 'AG1/cwofr', 'AG1/anofo', 'AG1/enstfo', 'AG1/jnzfo', 'AG1/bbfor', 'AG1/vtrof', 'AG1/tsdfo', 'AG1/sdvdrfo', 'AG1/svspfo', 'AG1/snrpfo', 'AG1/pdanfo', 'AG1/prlcsfo', 'AG1/smpfo', 'AG1/mdbofo', 'AG1/mwdfo', 'AG1/mchegof', 'AG1/lofcfo', 'AG1/ingnof', 'AG1/dcfofo', 'AG1/ctkofof', 'AG1/scengof', 'AG1/cevngio', 'AG1/bnstmo', 'AG1/aytof', 'AG1/cstaof', 'AG1/chconof', 'AG1/bisinof', 'AG1/gwrof', 'AG1/chrzfo', 'AG1/prfofo', 'AG1/vsofs', 'AG1/vocfa', 'AG1/chfofo', 'AG1/perlu', 'AG1/chefoe', 'AG1/canof', 'AG1/cadvof', 'AG1/agoffo', 'AG1/canyof', 'AG1/caudof', 'AG1/cbrdof', 'AG1/cbdvo', 'AG1/ccomuof', 'AG1/ccoplo', 'AG1/ccontof', 'AG1/ccrof', 'AG1/ccsuof', 
'AG1/cdatof', 'AG1/cdesof', 'AG1/cdigof', 'AG1/cevntof', 'AG1/cevnof', 'AG1/cxpof', 'AG1/cfutof', 'AG1/cgmof', 'AG1/cgrwof', 'AG1/cinof', 'AG1/cisof', 'AG1/cinoof', 'AG1/cinspo', 'AG1/cipco', 'AG1/cinvof', 'AG1/cknwof', 'AG1/clarnof', 'AG1/chlogof', 'AG1/cmarkof', 'AG1/cmer', 'AG1/cprocof', 'AG1/chprdof', 'AG1/chprmg', 'AG1/crepuof', 'AG1/crescof', 'AG1/cscenof', 'AG1/crevo', 'AG1/crsko', 'AG1/csalof', 'AG1/csecof', 'AG1/cstrao', 'AG1/cscof', 'AG1/ctalo', 'AG1/cwo', 'AG1/chteco', 'AG1/chtecof', 'AG1/cowk', 'AG1/lf', 'AG1/gw', 'swapnil_teke/8_nap_model', 'jun47ade/callama', 'darsankumar89/octilyassist', 'zctech/x-ai-kit', 'xiayu/wc-llama-bk-6', 'xiayu/llama3.1-wizard',
'janne/raindance', 'kelvi23/custom_axum', 'a99divx/lok', 'kelvi23/caller', 'gedesiwen/my-models', 'crown/craigsprompter', 'dylanravel/allied_interest', 'chevalblanc/claude-3-haiku', 'phonpadithpp/laosllm', 'Tales/massas', 'chimiste/llama-3.2-3b-graph', 'richasdy/hello', 'GyuHyeon/naps-llama-3.1-v0.6.0-f32', 'saish_15/tethysai_research', 'StoneSage/marcus', 'hungvturing/pd-mario', 'eggitai/gienwen', 'vladm90/vv2', 'wjwjx/apioverflow', 'JerickUN/javagpt', 'dougstrouth/blog_assistant', 'emre198/emreai', 'fbriones/freya', 'remington2002/vector2', 'richlee/mario', 'Hamberfim/myguru', 'bmizerany/pap', 'tryfonas/tref', 'rakalantari/myllama', 'lsctw/lsctwman', 'aratan/valeryq-coder',
'Kevinization/medicllama1.9.2.q9_1', 'Kevinization/medicllama1.9.2.q9', 'rumpl/llama3.1', 'laszlo/bob', 'niveo/laminha', 'starsnatched/thinkingsmolmistral', 'peter6432/cat', 'peter6432/test', 'gbejarano-mc/murrayllama', 'gurjant1229/smart-model', 'josepana/oda', 'kamil5b/ciwastra', 'divanshurc/wyzard-discovery', 'Jakub123/discord2.0', 'kaany/llm1', 'Javi/dev-genai-plexus', 'Akshita/testing-llama', 'Karlsefni/chatofexile', 'xiayu/wc-llama-bk-3', 'xiayu/wc-llama-bk-1', 'jacksonian_r_taylor/initial_testing', 'sezi_kim/ollama3.1', 'shamyukr2904/othopaedist', 'AshtonLKY/llama3.1narsim', 'mohamedrady/clockwok-temptation');
const AIOMATIC_EMBEDDING_OLLAMA_MODELS = array('nomic-embed-text', 'mxbai-embed-large', 'snowflake-arctic-embed', 'all-minilm', 'unclemusclez/jina-embeddings-v2-base-code', 'hellord/mxbai-embed-large-v1', 'znbang/bge', 'bge-m3', 'shaw/dmeta-embedding-zh', 'jina/jina-embeddings-v2-base-de', 'chroma/all-minilm-l6-v2-f32', 'bge-large', 'quentinz/bge-large-zh-v1.5', 'paraphrase-multilingual', 'milkey/m3e', 'jina/jina-embeddings-v2-base-en', 'chevalblanc/acge_text_embedding', 'chatfire/bge-m3', 'dztech/bge-large-zh', 'mofanke/acge_text_embedding', '893379029/piccolo-large-zh-v2', 'jina/jina-embeddings-v2-small-en', 'mofanke/dmeta-embedding-zh', 'milkey/gte', 'herald/dmeta-embedding-zh', 'nextfire/paraphrase-multilingual-minilm', 'jina/jina-embeddings-v2-base-es', 'milkey/dmeta-embedding-zh', 'cwchang/jina-embeddings-v2-base-zh', 'smartcreation/dmeta-embedding-zh', 'evilfreelancer/enbeddrus', 'smartcreation/bge-large-zh-v1.5', 'yxl/m3e', 'jmorgan/gte-small', 'shaw/dmeta-embedding-zh-small-q4', 'zylonai/multilingual-e5-large', 'royalpha/sentence-camembert-large', 'jeffh/intfloat-multilingual-e5-large', 'quentinz/bge-base-zh-v1.5', 'karuniaperjuangan/multilingual-e5-small', 'jeffh/intfloat-multilingual-e5-large-instruct', 'aerok/xiaobu-embedding-v2', 'zailiang/bge-large-zh-v1.5', 'shaw/dmeta-embedding-zh-small',
'aerok/acge_text_embedding', 'twwch/m3e-base', 'shaw/dmeta-embedding-zh-q4', 'viosay/conan-embedding-v1', 'smartwang/bge-large-zh-v1.5-f32.gguf', 'tazarov/all-minilm-l6-v2-f32', 'zw66/bgelarge', 'sunzhiyuan/suntray-embedding', 'joanfm/jina-embeddings-v2-base-en', 'jmorgan/nomic-embed-text', 'chinashrimp/jina-embeddings-v2-base-zh', 'albertogg/multi-qa-minilm-l6-cos-v1', 'bnksys/baia', 'imcurie/bge-large-en-v1.5', 'joanfm/jina-embeddings-v2-base-es', 'chevalblanc/text-embedding-3-small', 'shunyue/llama3-chinese-shunyue', '0ssamaak0/nomic-embed-text', 'theepicdev/nomic-embed-text', 'pankajrajdeo/sentence-transformers_all-minilm-l6-v2', 'kun432/cl-nagoya-ruri-large', 'locusai/multi-qa-minilm-l6-cos-v1', 'chinashrimp/xiaobu-embedding-v2', 'yuki_ho/bce-embedding', 'joanfm/jina-embeddings-v2-base-de', 'davisgao/m3e', 'zxf945/nomic-embed-text', 'quentinz/bge-small-zh-v1.5', 'zw66/llama3-8b-gguf', 'waterdrop/embeding', 'yxchia/paraphrase-multilingual-minilm-l12-v2', 'imac/zpoint_large_embedding_zh', 'zctech/x-ai-txt', 'jmorgan/all-minilm-l6', 'viosay/xiaobu-embedding-v2', 'plutonioumguy/bge-m3', 'zw66/llama3-8b', 'HuTangZhu/gte-small-zh', 'aerok/zpoint_large_embedding_zh', 'diepho/all-minilm', 'msc802/xiaobu-embedding-v2', 'zw66/llama3-chat-8.0bpw', 'woodylee1974/dmeta', 'modelbao/bge-large-zh-v1.5', 'zailiang/m3e', 'zw66/llama3-lora8b', 
'liebe-magi/multilingual-e5-large', 'kun432/cl-nagoya-ruri-base', 'stanus74/e5-base-sts-en-de', 'imcurie/bge-large-zh-v1.5', 'yuki_ho/conan-embedding-v1', 'zylonai/bge-m3', 'leoho0722/zpoint_large_embedding_zh', 'shirt/snowflake-arctic-secret', 'viosay/zpoint_large_embedding_zh', 'charaf/bge-m3-f32', 'ollamay/w3e', 'lrs33/bce-embedding-base_v1', 'jaluma/arabert-all-nli-triplet-matryoshka', 'bona/bge-m3-korean', 'lrs33/conan-embedding-v1', 'zylonai/paraphrase-multilingual-minilm-l12', 'ohko/bge-small-zh-hk', 'imcurie/bge-m3', 'yuki_ho/xiaobu-embedding-v2', 'ehd0309/lgko', 'cowolff/science_bge_large', 'aroxima/multilingual-e5-large-instruct', 'xiaoming/bge-large-zh-v1.5', 'xiaoming/multilingual-e5-large', 'xiaoming/bce-embedding-base_v1', 'lrs33/xiaobu-embedding-v2', 'lrs33/acge_text_embedding');
const AIOMATIC_TRAINING_MODELS = array('gpt-4o-2024-08-06', 'gpt-4o-mini-2024-07-18', 'gpt-4-0613', 'gpt-3.5-turbo-0125', 'gpt-3.5-turbo-1106', 'gpt-3.5-turbo-0613');
const AIOMATIC_TRAINING_MODELS_CHAT = array('gpt-4o-2024-08-06', 'gpt-4o-mini-2024-07-18', 'gpt-4-0613', 'gpt-3.5-turbo-0125', 'gpt-3.5-turbo-1106', 'gpt-3.5-turbo-0613');
const AIOMATIC_DEFAULT_TRAINING_MODEL = array('gpt-4o-mini-2024-07-18');
const AIOMATIC_OLLAMA_MODELS = array('llama3');
const AIOMATIC_OPENAI_SPEECH_MODELS = array('whisper-1');
const AIOMATIC_DEFAULT_MAX_TOKENS = 2048;
const AIOMATIC_DEFAULT_COMPLETION_TOKENS = 2000;
const AIOMATIC_MINIMUM_TOKENS_FOR_COMPLETIONS = 50;
const AIOMATIC_MINIMUM_TOKENS_FOR_CHAT = 50;
const AIOMATIC_MAX_HUGGINGFACE_TOKEN_COUNT = 2000;
const AIOMATIC_MAX_OLLAMA_TOKEN_COUNT = 4000;
const AIOMATIC_IS_DEBUG = false;
const AIOMATIC_EXCEPTED_POST_TYPES_FROM_EDITING = array('aiomatic_embeddings', 'aiomatic_file', 'aiomatic_remote_chat', 'aiomatic_convert', 'aiomatic_finetune', 'aiomatic_forms', 'aiomatic_personas', 'aiomatic_assistants', 'aiomatic_batches', 'aiomatic_omni_temp', 'aiomatic_editor_temp', 'aiomatic_omni_file', 'aiomatic_themes', 'aiomatic_user_data');
const AIOMATIC_AZURE_API_VERSION = '?api-version=2024-06-01';
const AIOMATIC_AZURE_API_VERSION_EMBEDDINGS = '?api-version=2024-06-01';
const AIOMATIC_AZURE_DALLE_API_VERSION = '?api-version=2023-06-01-preview';
const AIOMATIC_AZURE_DALLE3_API_VERSION = '?api-version=2024-06-01';
const AIOMATIC_AZURE_ASSISTANTS_API_VERSION = '?api-version=2024-05-01-preview';
const AIOMATIC_AZURE_BATCHES_API_VERSION = '?api-version=2024-10-21';
const AIOMATIC_AZURE_DEPLOYMENT_API_VERSION = '?api-version=2023-03-15-preview';
const AIOMATIC_AMAZON_CATEGORIES = array('AmazonVideo', 'Apparel', 'Appliances', 'ArtsAndCrafts', 'Automotive', 'Baby', 'Beauty', 'Books', 'Classical', 'Collectibles', 'Computers', 'CreditCards', 'DigitalMusic', 'DigitalEducationalResources', 'Electronics', 'EverythingElse', 'Fashion', 'FashionBaby', 'FashionBoys', 'FashionGirls', 'FashionMen', 'FashionWomen', 'ForeignBooks', 'Furniture', 
'GardenAndOutdoor', 'Garden', 'GiftCards', 'GroceryAndGourmetFood', 'Handmade', 'HealthPersonalCare', 'Hobbies', 'HomeAndKitchen', 'Home', 'Industrial', 'Jewelry', 'KindleStore', 'LocalServices', 'Lighting', 'Luggage', 
'MobileAndAccessories', 'LuxuryBeauty', 'Magazines', 'Miscellaneous', 'MobileApps', 'MoviesAndTV', 'Music', 'MusicalInstruments', 'OfficeProducts', 'PetSupplies', 'Photo', 'Shoes', 'Software', 'SportsAndOutdoors', 'ToolsAndHomeImprovement', 'ToysAndGames', 'Vehicles', 'VHS', 'VideoGames', 'Watches');
?>